#ifndef KEY_H
#define KEY_H

#include <avr/io.h>
#include <avr/eeprom.h>
#include "avr_utils.h"


#define KEY_CH1A_D		C,4						// digital-bit
#define KEY_CH2A_D		C,5						// digital-bit
#define KEY_CH1B_D		D,1						// digital-bit
#define KEY_CH2B_D		D,2						// digital-bit

#define KEY_A_CH1		4						// mux-channel ad 1
#define	KEY_A_CH2		5						// mux-channel ad 2

#define KEY_STATE_WAIT	0						// wait for key pressed
#define KEY_STATE_M1	1						// state mesure ad-value x
#define KEY_STATE_M2	2						// state mesure ad-value y

#define KEY_X_CHARS		40						// number of x-chars
#define KEY_Y_CHARS		20						// number of y-chars 

#define KEY_STORE		2						// store pos after x messure-cycle
#define KEY_R_START		60						// start with autorepeate
#define KEY_R_NEXT		70						// repeate autorepeate

#define KEY_PWM_OFFSET	0x58					// PWM-offset

#define KEY_INIT_CAL	1						// enable init-calibrate-funktion


extern volatile unsigned char key_state;		// debounced key state:
extern volatile unsigned char key_press;		// key press detect
extern volatile unsigned char key_rpt;			// key long press and repeat

extern volatile unsigned char key_cx;
extern volatile unsigned char key_cx1;
extern volatile unsigned char key_cy;
extern volatile unsigned char key_cy1;

extern volatile unsigned char key_val_chx;
extern volatile unsigned char key_val_chy;
extern volatile unsigned char key_val_state;
extern VoidFnct key_time_function;				// function call after process-key
extern volatile unsigned char key_count;

extern unsigned char ee_pwm_cal EEMEM;
extern unsigned char key_cal_x EEMEM;
extern unsigned char key_cal_y EEMEM;
extern unsigned char key_cal_x1 EEMEM;
extern unsigned char key_cal_y1 EEMEM;


void key_init(void);
unsigned char get_key_press( void );
void process_keys( void );
unsigned char get_key_pos( unsigned char *x,unsigned char *y );
unsigned char key_digital_pressed(void);
unsigned int key_calc_x(unsigned char char_x);
unsigned int key_transform_x(void);


#ifdef KEY_INIT_CAL
void key_init_contrast(void);
#endif

#endif
