/*************************************************************************
Title:	testing output to a HD44780 based LCD display.
Author:   Peter Fleury  <pfleury@gmx.ch>  http://jump.to/fleury
File:	 $Id: test_lcd.c,v 1.6 2004/12/10 13:53:59 peter Exp $
Software: AVR-GCC 3.3
Hardware: HD44780 compatible LCD text display
		  ATS90S8515/ATmega if memory-mapped LCD interface is used
		  any AVR with 7 free I/O pins if 4-bit IO port mode is used
**************************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#include <avr/delay.h>
#include "avr_utils.h"
#include "lcd.h"
#include "main.h"
#include "key.h"
#include "menu.h"

#define TEB	D,3


/*
** function prototypes
*/ 

void init(void)
{
	OUTPUT(TEB);
//	TCCR0B=3; //Prescaler= 64/1
//	TCNT0=0;  //Timer0 resetten
//	TIMSK0=1; //Overflow-Interrupt-Enable
//	TIFR0=0;  //Overflow-Flag-Bit
	
}

int counter=0;
 
ISR(TIMER0_OVF_vect)
{
	if(counter>=238)
	{
		if(GET(TEB))
			CLR(TEB);
		else
			SET(TEB);
		counter=0;
	}
	counter++;
}

int main(void)
{
//	unsigned char x,y;
	int tmp1=0;
	unsigned char tmp=0;
//	unsigned int i=0;
	unsigned char aa[9]="      ";

	key_init();
	lcd_init();

	init();
	sei();

	lcd_set_kontrast(eeprom_read_byte(&ee_pwm_cal));

	key_init_contrast();

	menu_init();

	tmp=' ';
	while( 1 )                                                          // Endlosschleife
	{

		if(get_key_press())
		{
			menu_do();
		}
		else
		{
			menu_do_post();
		}

//		i=char_pos;
//		lcd_puts("Test-Text");
//		char_pos=i;
//		lcd_putc(' ');

//		process_keys();

#ifdef tttt
		if(get_key_press())
		{
			lcd_gotoxy(0, 0);
			lcd_int(key_val_chx);
			lcd_gotoxy(0, 1);
			lcd_int(key_val_chy);
			lcd_gotoxy(0, 2);
			lcd_int(i++);
			lcd_gotoxy(x, y);
			lcd_putc(' ');
			get_key_pos(&x,&y);
			lcd_gotoxy(x, y);
			lcd_putc('@');
		}
		
#endif

		if(tmp1==0)
		{
		aa[0]=aa[1];
		aa[1]=aa[2];
		aa[2]=aa[3];
		aa[3]=aa[4];
		aa[4]=aa[5];
		aa[5]=tmp++;
		lcd_gotoxy(0, 12);
		lcd_mputs((char *)aa);
		if(tmp==129) tmp=' ';
		}
		tmp1++;
    }                                                                   // end while( 1 )

}

